summaryrefslogtreecommitdiffstats
path: root/Refactory
diff options
context:
space:
mode:
authormakefu <github@syntax-fehler.de>2011-08-06 01:56:55 +0200
committermakefu <github@syntax-fehler.de>2011-08-06 01:56:55 +0200
commit494b2e6d6d93bd6febbab2fa086fc43310228512 (patch)
tree3a0d0028daf2cefa70c49bae463a3923cb18f4c9 /Refactory
parent596c29972408c83a3e83bb3eb369734bd87d4f7b (diff)
parentd865d9db85cc283ae3e7be20dbe4441a4e69f7b3 (diff)
emergency merge
Diffstat (limited to 'Refactory')
-rwxr-xr-xRefactory/bin/git-clone-into48
1 files changed, 48 insertions, 0 deletions
diff --git a/Refactory/bin/git-clone-into b/Refactory/bin/git-clone-into
new file mode 100755
index 00000000..67e820e6
--- /dev/null
+++ b/Refactory/bin/git-clone-into
@@ -0,0 +1,48 @@
+#! /bin/sh
+#
+# usage: git-clone-into repository directory
+#
+set -euf
+
+tempdir() {
+ set -- `tempnam $1`
+ mkdir $1
+ echo $1
+}
+
+## [prefix] -> tempnam
+tempnam() {
+ until set -- $1 ${1-}`candnam` && ! test -e $2; do :; done
+ echo $2
+}
+
+candnam() {
+ uuidgen 2>/dev/null || date +%s%N
+}
+
+
+
+ tmp_remote=`candnam`
+ tmp_branch=`candnam`
+
+ subdir=$2
+ if test -e $subdir; then
+ echo 'You are made of stupid!' >&2
+ exit 23
+ fi
+ tmpdir=`tempdir /tmp/tempdir-`
+ #trap "test -d $tmpdir && rm -vfR $tmpdir" EXIT
+ trap "test -d $tmpdir && rm -fR $tmpdir" EXIT
+ repository="${1-$repository}"
+ git clone "$repository" $tmpdir
+ (cd $tmpdir
+ subdir="$subdir" git filter-branch --tree-filter '
+ if ! test -d $subdir; then
+ mkdir -p $subdir
+ git ls-tree -z --name-only $GIT_COMMIT | xargs -I. --null mv . $subdir
+ fi
+ '
+ git checkout -b $tmp_branch)
+ git remote add $tmp_remote $tmpdir
+ git fetch $tmp_remote
+ git merge $tmp_remote/$tmp_branch # TODO configurable branch